cabal-version:      3.0
-- The cabal-version field refers to the version of the .cabal specification,
-- and can be different from the cabal-install (the tool) version and the
-- Cabal (the library) version you are using. As such, the Cabal (the library)
-- version used must be equal or greater than the version stated in this field.
-- Starting from the specification version 2.2, the cabal-version field must be
-- the first thing in the cabal file.

-- Initial package description 'souplesse' generated by
-- 'cabal init'. For further documentation, see:
--   http://haskell.org/cabal/users-guide/
--
-- The name of the package.
name:               souplesse

-- The package version.
-- See the Haskell package versioning policy (PVP) for standards
-- guiding when and how versions should be incremented.
-- https://pvp.haskell.org
-- PVP summary:     +-+------- breaking API changes
--                  | | +----- non-breaking API additions
--                  | | | +--- code changes with no API change
version:            0.1.0.0

-- A short (one-line) description of the package.
-- synopsis:

-- A longer description of the package.
-- description:

-- The license under which the package is released.
license:            AGPL-3.0-only

-- The file containing the license text.
license-file:       LICENSE

-- The package author(s).
author:             Daniel Barlow

-- An email address to which users can send suggestions, bug reports, and patches.
maintainer:         <dan@telent.net>

-- A copyright notice.
-- copyright:
category:           Web
build-type:         Simple

-- Extra doc files to be distributed with the package, such as a CHANGELOG or a README.
extra-doc-files:    CHANGELOG.md

-- Extra source files to be distributed with the package, such as examples, or a tutorial module.
-- extra-source-files:

common warnings
    ghc-options: -Wall

executable souplesse
    -- Import common warning flags.
    import:           warnings

    -- .hs or .lhs file containing the Main module.
    main-is:          Main.hs

    -- Modules included in this executable, other than Main.
    -- other-modules:

    -- LANGUAGE extensions used by modules in this package.
    -- other-extensions:

    -- Other library packages from which modules are imported.
    build-depends:
        base ^>=4.18.2.1
      , aeson
      , souplesse-lib
      , text
      , bytestring
      , persistent
      , persistent-postgresql
      , resourcet
      , monad-logger
      , time
      , transformers
      , yesod-core == 1.6.25.1
      , yesod-static
      , yesod-form
      , yesod-persistent

    -- Directories containing source files.
    hs-source-dirs:   app

    -- Base language which the package is written in.
    default-language: GHC2021

-- mostly copied from
-- https://functional.works-hub.com/learn/basic-unit-testing-in-haskell-using-hunit-and-cabal-29e47

library souplesse-lib
    exposed-modules:
        Track
        Point
        Session
    hs-source-dirs:
        lib
    build-depends:
        base >=4.7 && <5
      , aeson
      , bytestring
      , xml-conduit
      , time
      , containers
      , text
      , raw-strings-qq
      , transformers
      , persistent
      , persistent-postgresql
      , iso8601-time
    default-language: GHC2021

test-suite tests
    type: exitcode-stdio-1.0
    main-is: UnitTest.hs
    hs-source-dirs:
        tests
    build-depends:
        base >=4.7 && <5
      , souplesse-lib
      , raw-strings-qq
      , time
      , HUnit
    default-language: GHC2021
